#if !defined(AFX_CALVIEW_H__634A3800_F0DC_11D2_8F48_00805FBDCBE4__INCLUDED_)
#define AFX_CALVIEW_H__634A3800_F0DC_11D2_8F48_00805FBDCBE4__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// CalView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCalculatorView view
#include "standard.h"
#include "CalDoc.h"


class _declspec(dllexport) CCalculatorView : public CStandardView
{
public:
	CCalculatorView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CCalculatorView)

// Attributes
public:
    int          m_iOperandType;

    CString  m_strMsg;
	CFont*       m_Font;
    CFont*       operFont;
    
	CStatic*     m_txtVar1;
    CStatic*     m_txtVar2;
	CStatic*     m_txtResult;
	CStatic*     m_txtOperand;
	CStatic*     m_txtDocMsg;

    CEdit*       m_editVar1;
    CEdit*       m_editVar2;
    CEdit*       m_editResult;
	CEdit*       m_editOperand;
	CEdit*       m_editDocMsg;

	CButton*     m_btnCalculation;

// Operations
public:
	//{{AFX_DATA(CCalculatorView)
	int		m_iVar1;
	int		m_iVar2;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCalculatorView)
	public:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnInitialUpdate();
	virtual void DoDataExchange(CDataExchange* pDX);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCalculatorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

    void GetMsgFromDocument(CString msg);
	// Generated message map functions
public:
	//{{AFX_MSG(CCalculatorView)
	afx_msg void OnCalculatorexit();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnCalculate();
	afx_msg void OnAdd();
	afx_msg void OnUpdateAdd(CCmdUI* pCmdUI);
	afx_msg void OnSub();
	afx_msg void OnUpdateSub(CCmdUI* pCmdUI);
	afx_msg void OnTime();
	afx_msg void OnUpdateTime(CCmdUI* pCmdUI);
	afx_msg void OnDvd();
	afx_msg void OnUpdateDvd(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CALVIEW_H__634A3800_F0DC_11D2_8F48_00805FBDCBE4__INCLUDED_)
