// ebdlib2.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "ebdlib2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static AFX_EXTENSION_MODULE EBDLID2DLL = { NULL, NULL };


extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("EBDLIB2.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(EBDLID2DLL, hInstance))
			return 0;


	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("EBDLIB2.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(EBDLID2DLL);
	}
	return 1;   // ok
}


_declspec(dllexport) int InitTemplate(CDocTemplate** pDocTemplate)
{
	 
	new CDynLinkLibrary(EBDLID2DLL);
	*pDocTemplate =  new CSingleDocTemplate(ID_CALCULATOR,
			                               RUNTIME_CLASS(CCalculatorDoc),
			                               RUNTIME_CLASS(CCalculatorFrame),
			                               RUNTIME_CLASS(CCalculatorView));
					 

	if(*pDocTemplate == NULL)
		return 0;
	
	return 1;
}


_declspec(dllexport) int GetModuleData(int *iID, CString* nickname)
{
	new CDynLinkLibrary(EBDLID2DLL);

	*iID = ID_CALCULATOR;
	*nickname = "Calculator";

	return 1;
}
