// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "main.h"
#include "mainDoc.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND_RANGE(IDM_BASE, IDM_BASE+140, OnModule)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI_RANGE(IDM_BASE, IDM_BASE+140, OnUpdateBase)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
    m_bMsetup = FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnModule(UINT nID) 
{
	// TODO: Add your command handler code here
    int i = nID - IDM_BASE;
	CMainDoc* pDoc = (CMainDoc*)GetActiveDocument();
	pDoc->PopModule(i);
}

void CMainFrame::OnUpdateBase(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(!m_bMsetup)
	{
		CMainDoc* pDoc = (CMainDoc*)GetActiveDocument();
	
	    CMenu* pMenu = GetMenu();
        CMenu* pSubMenu = pMenu->GetSubMenu(3);
	    pSubMenu->DeleteMenu(0, MF_BYPOSITION);


	    for(int i = 0; i < pDoc->m_ListLibInfo.GetSize(); i++)
		{	
	        pSubMenu->AppendMenu(MF_ENABLED|
							 MF_STRING,
							 IDM_BASE+i,
						     pDoc->m_ListLibInfo[i]->m_nickName
							 );
		}
		m_bMsetup = TRUE;
	}
}
