// mainDoc.h : interface of the CMainDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDOC_H__8EF22EFC_EDB6_11D2_8F46_00805FBDCBE4__INCLUDED_)
#define AFX_MAINDOC_H__8EF22EFC_EDB6_11D2_8F46_00805FBDCBE4__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Standard.h"
//#include "ChildFrame.h"

//#define ID_ROUND  101
class CLibInfo : public CObject
{
public:
	CLibInfo()
	{
	   m_uTypeIDD = 0;  
	   m_hinstLib = NULL;
	   m_nickName.Empty();
	};
	
	~CLibInfo()
	{
	   m_uTypeIDD = 0;  
	   m_hinstLib = NULL;
	   m_nickName.Empty();
	};

public:
	int          m_uTypeIDD;  //resource ID of Child Module 
	CString      m_nickName;  //module nickname
	HINSTANCE    m_hinstLib;  //the instance handle of the module
	                          //library
};


class CMainDoc : public CStandardDoc
{
public: // create from serialization only
	CMainDoc();
	DECLARE_DYNCREATE(CMainDoc)

// Attributes
public:
  	int    m_iWndNum;

	

// Operations
public:
//	CTypedPtrArray<CObArray, CDocTemplate*> m_ListChildDocTemplate;

    CTypedPtrArray<CObArray, CChildFrame*> m_ListChildFrame;  

    CTypedPtrArray<CObArray, CLibInfo*> m_ListLibInfo;  

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	void GetMsgFromView(int ID, int pin, CString msg);
	void ReleaseChildWindow(int ID, int pin);
    void PopModule(int nID); 
// Generated message map functions
public:
	//{{AFX_MSG(CMainDoc)
	afx_msg void OnWindowlist();
	afx_msg void OnUpdateWindowlist(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDOC_H__8EF22EFC_EDB6_11D2_8F46_00805FBDCBE4__INCLUDED_)
