// RdView.cpp : implementation file
//

#include "stdafx.h"
#include "ebdlib1.h"
#include "RdView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CRoundView

IMPLEMENT_DYNCREATE(CRoundView, CView)

CRoundView::CRoundView()
   : CStandardView()
{
	//{{AFX_DATA_INIT(CRoundView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_iCounter = 0;
	m_strName = "Bitmap Module";
	m_strMsg.Empty();
	IDD = ID_ROUND;
}

CRoundView::~CRoundView()
{
	m_iCounter = 0;
	m_strMsg.Empty();
}


BEGIN_MESSAGE_MAP(CRoundView, CView)
	//{{AFX_MSG_MAP(CRoundView)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_SENDMSG, OnSendmsg)
	ON_COMMAND(IDM_ROUNDEXIT, OnRoundexit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRoundView diagnostics

#ifdef _DEBUG
void CRoundView::AssertValid() const
{
	CStandardView::AssertValid();
}

void CRoundView::Dump(CDumpContext& dc) const
{
	CStandardView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRoundView message handlers
void CRoundView::GetMsgFromDocument(CString msg)
{
    m_strMsg = "Message from main frame: ";
	m_strMsg += msg;

	Invalidate(FALSE);
}

void CRoundView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CDC      dcBitmap;
	CBitmap  bmBitmap;
	CBitmap* pbmBitmapOld;
	CRect    rect;
	
	GetClientRect(&rect);

	// create another device context
	dcBitmap.CreateCompatibleDC(&dc);

	// draw the background bitmap
	bmBitmap.LoadBitmap(IDB_ROUND);
	pbmBitmapOld = dcBitmap.SelectObject(&bmBitmap);
	
	dc.BitBlt(0, 0, rect.Width(), rect.Height(), &dcBitmap, 0, 0, SRCCOPY);
	dcBitmap.SelectObject(pbmBitmapOld);
	bmBitmap.DeleteObject();

	dc.SetBkMode(TRANSPARENT);
	dc.TextOut(10, 10, m_strMsg);
	// Do not call CStandardView::OnPaint() for painting messages
   
}

void CRoundView::OnSendmsg() 
{
	// TODO: Add your control notification handler code here
    GetDocument()->GetMsgFromView(IDD, m_iPin, "Hello Main Frame!");	
}

void CRoundView::OnRoundexit() 
{
	// TODO: Add your command handler code here
	GetParent()->SendMessage(WM_CLOSE);	
}

void CRoundView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
    if(pHint == NULL)
		return;

    if(lHint == UPDATE_ONE)
	   m_strMsg = "This broadcast information is UPDATE_ONE!";
    else if(lHint == UPDATE_TWO)
	   m_strMsg = "This broadcast information is UPDATE_TWO!";

	WNDINFO* info = (WNDINFO *)pHint;
	
	if(info->m_iID == (int)IDD && info->m_iPin == m_iPin)
		this->MessageBox("Sorry, no setting here!", "Image", MB_OK);
    
	Invalidate(FALSE);
}

