// ebdlib3.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "ebdlib3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static AFX_EXTENSION_MODULE EBDLID3DLL = { NULL, NULL };


extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("EBDLIB3.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(EBDLID3DLL, hInstance))
			return 0;


	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("EBDLIB3.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(EBDLID3DLL);
	}
	return 1;   // ok
}


_declspec(dllexport) int InitTemplate(CDocTemplate** pDocTemplate)
{
	 
	new CDynLinkLibrary(EBDLID3DLL);
	*pDocTemplate =  new CSingleDocTemplate(ID_3D,
			                               RUNTIME_CLASS(C3DDocument),
			                               RUNTIME_CLASS(C3DFrame),
			                               RUNTIME_CLASS(C3DView));
					 

	if(*pDocTemplate == NULL)
		return 0;
	
	return 1;
}



_declspec(dllexport) int GetModuleData(int *iID, CString* nickname)
{
	new CDynLinkLibrary(EBDLID3DLL);

	*iID = ID_3D;
	*nickname = "3D_Animation";
	
	return 1;
}
